import _mergeJSXProps from 'babel-helper-vue-jsx-merge-props';
import _regeneratorRuntime from 'babel-runtime/regenerator';
import _asyncToGenerator from 'babel-runtime/helpers/asyncToGenerator';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import { initDefaultProps, getSlotOptions } from '../_util/props-util';
import PropTypes from '../_util/vue-types';
import { Form, Row, Col, Input, Select } from 'ant-design-vue';
var FormItem = Form.Item;
var TextArea = Input.TextArea;

var Option = Select.Option;
var AxForm = {
  name: 'AxForm',
  props: initDefaultProps({
    param: PropTypes.object,
    option: PropTypes.array,
    layout: PropTypes.string
  }, {
    param: {},
    option: [],
    layout: 'grid'
  }),
  data: function data() {
    return {
      _option: []
    };
  },
  created: function created() {
    this.$data._option = this.option;
  },

  methods: {
    getItem: function getItem(item) {
      switch (item.type) {
        case 'input':
          return this.getInput(item);
        case 'select':
          return this.getSelect(item);
        case 'textarea':
          return this.getTextarea(item);
        case 'selects':
          return this.getSelects(item);
      }
    },
    getInput: function getInput(item) {
      var _this = this;

      var h = this.$createElement;
      var addonAfter = item.addonAfter;

      var change = function change(e) {
        _this.param[item.model] = e.target.value;
        item.change && item.change(_this.param[item.model]);
      };
      return h(
        Input,
        {
          attrs: { disabled: item.disabled, placeholder: item.placeholder, value: this.param[item.model] },
          on: {
            'change': change
          },
          style: { width: item.width } },
        [addonAfter && h('div', { slot: 'addonAfter', domProps: {
            'innerHTML': addonAfter
          }
        })]
      );
    },
    getSelect: function getSelect(item) {
      var _this2 = this;

      var h = this.$createElement;

      var options = item.options,
          change = item.change,
          model = item.model,
          span = item.span,
          label = item.label,
          type = item.type,
          props = _objectWithoutProperties(item, ['options', 'change', 'model', 'span', 'label', 'type']); // eslint-disable-line no-unused-vars


      var list = [];
      var onChange = function onChange(value) {
        _this2.param[model] = value;
        change && change(_this2.param[model]);
      };
      var filterOption = function filterOption(inputValue, option) {
        return true;
      };
      var getSlotOptions = function () {
        var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(options) {
          return _regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (!(typeof options === 'function')) {
                    _context.next = 6;
                    break;
                  }

                  _context.next = 3;
                  return options();

                case 3:
                  item.options = _context.sent;
                  _context.next = 7;
                  break;

                case 6:
                  list = options;

                case 7:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, _this2);
        }));

        return function getSlotOptions(_x) {
          return _ref.apply(this, arguments);
        };
      }();
      getSlotOptions(options);
      return h(
        Select,
        _mergeJSXProps([props, {
          attrs: { value: this.param[model], optionFilterProp: 'label', mode: item.mode, placeholder: item.placeholder || '请选择' },
          on: {
            'change': onChange
          },
          style: { width: item.width } }]),
        [list.map(function (option, index) {
          var label = option.label,
              pProps = _objectWithoutProperties(option, ['label']);

          return h(
            Option,
            _mergeJSXProps([{ key: index }, pProps, {
              attrs: { value: option.value, label: label || option.value }
            }]),
            [label || option.value]
          );
        })]
      );
    },
    getTextarea: function getTextarea(item) {
      var _this3 = this;

      var h = this.$createElement;

      var model = item.model,
          span = item.span,
          label = item.label,
          type = item.type,
          change = item.change,
          props = _objectWithoutProperties(item, ['model', 'span', 'label', 'type', 'change']); // eslint-disable-line no-unused-vars


      var onChange = function onChange(e) {
        _this3.param[model] = e.target.value;
        change && change(_this3.param[model]);
      };
      return h(TextArea, _mergeJSXProps([props, {
        attrs: { value: this.param[model] },
        on: {
          'change': onChange
        },
        style: { width: item.width } }]));
    },
    getSelects: function getSelects(item) {
      var _this4 = this;

      var h = this.$createElement;
      var selects = item.selects;

      return h(
        'div',
        { 'class': 'selects ' + item['class'], style: { width: item.width } },
        [selects.map(function (select, index) {
          return h(
            'div',
            { key: index },
            [select.before && h(
              'div',
              { 'class': 'before' },
              [select.before]
            ), _this4.getSelect(select), select.after && h(
              'div',
              { 'class': 'after' },
              [select.after]
            )]
          );
        })]
      );
    }
  },
  render: function render() {
    var _this5 = this;

    var h = arguments[0];
    var layout = this.layout;

    var option = this.$data._option;
    return h(
      'div',
      { 'class': 'ax-form' },
      [h(Form, [layout === 'flow' ? option.map(function (row) {
        return row.map(function (col) {
          return h(
            FormItem,
            {
              attrs: { label: col.label },
              'class': 'ax-form-item ax-form-flow-item' },
            [_this5.getItem(col)]
          );
        });
      }) : option.map(function (row, rowIndex) {
        return h(
          Row,
          { key: rowIndex },
          [row.map(function (col, colIndex) {
            return h(
              Col,
              {
                attrs: { span: col.span, offset: col.offset },
                key: colIndex, 'class': 'ax-form-item' },
              [h(
                FormItem,
                {
                  attrs: { label: col.label, labelCol: col.labelCol, wrapperCol: col.wrapperCol }
                },
                [_this5.getItem(col)]
              )]
            );
          })]
        );
      })])]
    );
  }
};
export default Form.create()(AxForm);