'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babelHelperVueJsxMergeProps = require('babel-helper-vue-jsx-merge-props');

var _babelHelperVueJsxMergeProps2 = _interopRequireDefault(_babelHelperVueJsxMergeProps);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _propsUtil = require('../_util/props-util');

var _vueTypes = require('../_util/vue-types');

var _vueTypes2 = _interopRequireDefault(_vueTypes);

var _antDesignVue = require('ant-design-vue');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var FormItem = _antDesignVue.Form.Item;
var TextArea = _antDesignVue.Input.TextArea;

var Option = _antDesignVue.Select.Option;
var AxForm = {
  name: 'AxForm',
  props: (0, _propsUtil.initDefaultProps)({
    param: _vueTypes2['default'].object,
    option: _vueTypes2['default'].array,
    layout: _vueTypes2['default'].string
  }, {
    param: {},
    option: [],
    layout: 'grid'
  }),
  data: function data() {
    return {
      _option: []
    };
  },
  created: function created() {
    this.$data._option = this.option;
  },

  methods: {
    getItem: function getItem(item) {
      switch (item.type) {
        case 'input':
          return this.getInput(item);
        case 'select':
          return this.getSelect(item);
        case 'textarea':
          return this.getTextarea(item);
        case 'selects':
          return this.getSelects(item);
      }
    },
    getInput: function getInput(item) {
      var _this = this;

      var h = this.$createElement;
      var addonAfter = item.addonAfter;

      var change = function change(e) {
        _this.param[item.model] = e.target.value;
        item.change && item.change(_this.param[item.model]);
      };
      return h(
        _antDesignVue.Input,
        {
          attrs: { disabled: item.disabled, placeholder: item.placeholder, value: this.param[item.model] },
          on: {
            'change': change
          },
          style: { width: item.width } },
        [addonAfter && h('div', { slot: 'addonAfter', domProps: {
            'innerHTML': addonAfter
          }
        })]
      );
    },
    getSelect: function getSelect(item) {
      var _this2 = this;

      var h = this.$createElement;
      var options = item.options,
          change = item.change,
          model = item.model,
          span = item.span,
          label = item.label,
          type = item.type,
          props = (0, _objectWithoutProperties3['default'])(item, ['options', 'change', 'model', 'span', 'label', 'type']); // eslint-disable-line no-unused-vars

      var list = [];
      var onChange = function onChange(value) {
        _this2.param[model] = value;
        change && change(_this2.param[model]);
      };
      var filterOption = function filterOption(inputValue, option) {
        return true;
      };
      var getSlotOptions = function () {
        var _ref = (0, _asyncToGenerator3['default'])( /*#__PURE__*/_regenerator2['default'].mark(function _callee(options) {
          return _regenerator2['default'].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (!(typeof options === 'function')) {
                    _context.next = 6;
                    break;
                  }

                  _context.next = 3;
                  return options();

                case 3:
                  item.options = _context.sent;
                  _context.next = 7;
                  break;

                case 6:
                  list = options;

                case 7:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, _this2);
        }));

        return function getSlotOptions(_x) {
          return _ref.apply(this, arguments);
        };
      }();
      getSlotOptions(options);
      return h(
        _antDesignVue.Select,
        (0, _babelHelperVueJsxMergeProps2['default'])([props, {
          attrs: { value: this.param[model], optionFilterProp: 'label', mode: item.mode, placeholder: item.placeholder || '请选择' },
          on: {
            'change': onChange
          },
          style: { width: item.width } }]),
        [list.map(function (option, index) {
          var label = option.label,
              pProps = (0, _objectWithoutProperties3['default'])(option, ['label']);

          return h(
            Option,
            (0, _babelHelperVueJsxMergeProps2['default'])([{ key: index }, pProps, {
              attrs: { value: option.value, label: label || option.value }
            }]),
            [label || option.value]
          );
        })]
      );
    },
    getTextarea: function getTextarea(item) {
      var _this3 = this;

      var h = this.$createElement;
      var model = item.model,
          span = item.span,
          label = item.label,
          type = item.type,
          change = item.change,
          props = (0, _objectWithoutProperties3['default'])(item, ['model', 'span', 'label', 'type', 'change']); // eslint-disable-line no-unused-vars

      var onChange = function onChange(e) {
        _this3.param[model] = e.target.value;
        change && change(_this3.param[model]);
      };
      return h(TextArea, (0, _babelHelperVueJsxMergeProps2['default'])([props, {
        attrs: { value: this.param[model] },
        on: {
          'change': onChange
        },
        style: { width: item.width } }]));
    },
    getSelects: function getSelects(item) {
      var _this4 = this;

      var h = this.$createElement;
      var selects = item.selects;

      return h(
        'div',
        { 'class': 'selects ' + item['class'], style: { width: item.width } },
        [selects.map(function (select, index) {
          return h(
            'div',
            { key: index },
            [select.before && h(
              'div',
              { 'class': 'before' },
              [select.before]
            ), _this4.getSelect(select), select.after && h(
              'div',
              { 'class': 'after' },
              [select.after]
            )]
          );
        })]
      );
    }
  },
  render: function render() {
    var _this5 = this;

    var h = arguments[0];
    var layout = this.layout;

    var option = this.$data._option;
    return h(
      'div',
      { 'class': 'ax-form' },
      [h(_antDesignVue.Form, [layout === 'flow' ? option.map(function (row) {
        return row.map(function (col) {
          return h(
            FormItem,
            {
              attrs: { label: col.label },
              'class': 'ax-form-item ax-form-flow-item' },
            [_this5.getItem(col)]
          );
        });
      }) : option.map(function (row, rowIndex) {
        return h(
          _antDesignVue.Row,
          { key: rowIndex },
          [row.map(function (col, colIndex) {
            return h(
              _antDesignVue.Col,
              {
                attrs: { span: col.span, offset: col.offset },
                key: colIndex, 'class': 'ax-form-item' },
              [h(
                FormItem,
                {
                  attrs: { label: col.label, labelCol: col.labelCol, wrapperCol: col.wrapperCol }
                },
                [_this5.getItem(col)]
              )]
            );
          })]
        );
      })])]
    );
  }
};
exports['default'] = _antDesignVue.Form.create()(AxForm);